#include <stdio.h>
#include <stdlib.h>
#include "2d.h"
#include "beaconChooser.h"


#include <SDL/SDL.h>
#include <SDL/SDL_gfxPrimitives.h>

#define WIDTH  800
#define HEIGHT 600

#define CX (WIDTH/2)
#define CY (HEIGHT/2)

#define CLineRGBA(A,B,C,D,E,F,G,H,I)  lineRGBA((A),(B+CX),(-C+CY),(D+CX),(-E+CY),(F),(G),(H),(I))
#define PLineRGBA(A,B,C,D,E,F,G)  CLineRGBA((A),B.x,B.y,C.x,C.y,(D),(E),(F),(G))
#define LLineRGBA(A,B,C,D,E,F)  CLineRGBA((A),B.p1.x,B.p1.y,B.p2.x,B.p2.y,(C),(D),(E),(F))

#define CCircleRGBA(A,B,C,D,E,F,G,H)    circleRGBA((A),(B+CX), (-C+CY), (D), (E),(F),(G),(H))
#define PCircleRGBA(A,B,C,D,E,F,G)      CCircleRGBA((A),(B.x),(B.y),(C),(D),(E),(F),(G))

// #define deg2rad(A)  ((A)*(M_PI/180))


void CrossHair(SDL_Surface *screen, int px, int py) ;


void Slock(SDL_Surface *screen) {
  if ( SDL_MUSTLOCK(screen) ) {
    if ( SDL_LockSurface(screen) < 0 ) {
      return;
    }
  }
}

void Sulock(SDL_Surface *screen) {
  if ( SDL_MUSTLOCK(screen) ) {
    SDL_UnlockSurface(screen);
  }
}


void CrossHair(SDL_Surface *screen, int px, int py) {
   CLineRGBA(screen, px-8, py, px+8, py, 128, 128, 128, 128);
   CLineRGBA(screen, px, py-8, px, py+8, 128, 128, 128, 128);
}

void DrawScene(SDL_Surface *screen, int px, int py) {

  point2d_t beacons[8];
  float    rotations[8];
  unsigned int i;

  hit_t result;
   
  printf("float angles[] = {");
  for(i = 0; i < 8; i++) {
     setPoint(&beacons[i], pt(200,0));
     rotations[i] = (rand() % (360*4))/4;
     printf("%f, ", rotations[i]);
     rotatez(&beacons[i],  deg2rad(rotations[i]) );     
     PCircleRGBA(screen, beacons[i],2, 255,255,255,50+((205/7)*i)) ;       
  }  
  printf(" };\n");
  getSet( &result, rotations, 8 );
  PLineRGBA(screen, beacons[result.i] ,beacons[result.j], 255,0,0,255);
  PLineRGBA(screen, beacons[result.j] ,beacons[result.k], 0,255,0,255);
  PLineRGBA(screen, beacons[result.k] ,beacons[result.i], 0,0,255,255);
  
  
   
  Slock(screen);
  

  
 
 CrossHair(screen, 0, 0);
 
  
  Sulock(screen);
  SDL_Flip(screen);
}




int main(int argc, char *argv[]) {

  int done;
  int pass;
  SDL_Rect foo ={0, 0, WIDTH, HEIGHT};
  int x, y;
  char tracking;
  char flag;
  time_t t;
  
  srand((unsigned) time(&t));

  if ( SDL_Init(SDL_INIT_VIDEO) < 0 ) {
    printf("Unable to init SDL: %s\n", SDL_GetError());
    exit(1);
  }
  atexit(SDL_Quit);

  SDL_Surface *screen;
  screen=SDL_SetVideoMode(WIDTH, HEIGHT, 32,SDL_HWSURFACE|SDL_DOUBLEBUF);
  if ( screen == NULL ) {
    printf("Unable to set %dx%d video: %s\n",WIDTH, HEIGHT, SDL_GetError());
    exit(1);
  }
  
  tracking = 0;
  pass = 0;
  done = 0;
  flag = 0;
  while(done == 0) {
    SDL_Event event;

    while ( SDL_PollEvent(&event) ) {
      if ( event.type == SDL_QUIT )  {  done = 1;  }

      if ( event.type == SDL_KEYDOWN ) {
        if ( event.key.keysym.sym == SDLK_ESCAPE ) { done = 1; }        
       // if ( event.key.keysym.sym == 'e' )         { pass++; }
       // if ( event.key.keysym.sym == 'x' )         { pass--; }
        
      }
      
      if ( event.type == SDL_MOUSEBUTTONDOWN ) {
        // turn on tracking
        flag = 1;
      }
      
      if ( event.type == SDL_MOUSEBUTTONUP ) {
      //  flag = 0;
      }
      /*
      if (tracking) {
        SDL_GetMouseState(&x, &y);
        x = x-CX;
        y = -(y-CY);
      }
      */
            
    }
    
   if (flag) {
      SDL_FillRect(screen, &foo , 0);
      DrawScene(screen, x, y);
      flag = 0;
   }
   
   usleep(80);
  }

  return 0;
}
